﻿//---------------------------------------------------------------------------
//
//   SetX0
//
//          Copyright(C) 2014, Tark
//
//    X座標±0.001以下の頂点をX=0に揃える
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"
#include "CMQObject.h"
#include "SetX0.h"

//---------------------------------------------------------------------------
//  MQGetPlugInID
//---------------------------------------------------------------------------
void SetX0::GetPlugInID(DWORD *Product, DWORD *ID)
{
	*Product = 0xE3F7A830;
	*ID = 0xBD9A1881;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//---------------------------------------------------------------------------
const char *SetX0::GetPlugInName(void)
{
	return "SetX0 ver.1.2 Copyright(C) 2014, Tark.";
}

//---------------------------------------------------------------------------
//  MQEnumString
//---------------------------------------------------------------------------
const char *SetX0::EnumString(int index)
{
	switch(index) {
	case 0: return "SetX0(cur)"; break;
	case 1: return "SetX0 select(cur)"; break;
	case 2: return "SetX0(all)"; break;
	case 3: return "SetX0 select(all)"; break;
	}
	return nullptr;
}

MQBasePlugin *GetPluginClass()
{
	static SetX0 plugin;
	return &plugin;
}

BOOL SetX0::Execute(int index, MQDocument doc_)
{
	cmq::CMQDocument doc = cmq::CMQDocument(doc_);
	cmq::CMQObject cur = doc.getCurrentObject();
	switch(index) {
	case 0:
		return setx0(cur);
	case 1:
		return setx0selected(cur);
	case 2:
	case 3:
		{
			BOOL result = false;
			for(int i = 0; i < doc.getObjectCount(); i++) {
				cmq::CMQObject obj = doc.getObject(i);
				if(!obj.isLive()) {
					continue;
				}
				if(obj.getLocking() || !obj.getVisible()) {
					continue;
				}
				if(index == 2) {
					result |= setx0(obj);
				}
				else {
					result |= setx0selected(obj);
				}
			}
			return result;
		}
	}
	return FALSE;
}

SetX0::SetX0()
{
}

SetX0::~SetX0()
{
}

BOOL SetX0::setx0(cmq::CMQObject &obj)
{
	cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer(&obj);
	for(auto vit = vcontainer.begin(); vit != vcontainer.end(); ++vit) {
		MQPoint p = obj.getVertex(vit.index());
		if(abs(p.x) < 0.001f) {
			p.x = 0;
		}
		obj.setVertex(vit.index(), p);
	}
	return TRUE;
}

BOOL SetX0::setx0selected(cmq::CMQObject &obj)
{
	cmq::CMQContainer<cmq::CMQVertex, cmq::CMQObject> vcontainer(&obj);
	for(auto vit = vcontainer.begin(); vit != vcontainer.end(); ++vit) {
		if(vit->isSelect()) {
			MQPoint p = obj.getVertex(vit.index());
			p.x = 0;
			obj.setVertex(vit.index(), p);
		}
	}
	return TRUE;
}
